xiyyanggege 发表于 2015-1-25 15:43:40

求大神帮忙看看我这程序有什么问题

对话框程序
geardcl:dialog
{         label="请输入齿轮参数" ;
         :edit_box
       {        label="请输入齿轮模数" ;   key="m" ;
edit_width=15;   value="4" ;          }
        :edit_box
        {   label="请输入齿轮齿数" ;        key="z" ;
edit_width=15;    value="24" ;   }
        :edit_box
       {         label="请输入齿轮宽度"; key="H" ;
edit_width=15;    value="6" ;          }
        :edit_box
       {         label="请输入齿轮轴径";key="zj" ;       
edit_width=15;        value="14" ;          }
:edit_box
       {         label="请输入齿轮轮辐厚度";       key="LF" ;
edit_width=15;        value="8";   }
      
ok_only;   }

绘图程序
(defun c:chilun(/ dcl_ia)
   (setq dcl_ia (load_dialog "gear.dcl"))
   (if (not (new_dialog "geardcl" dcl_ia))
   (exit))
(action_tile "m" "(setq m(atoi(get_tile $key)))")
(action_tile "z" "(setq z(atoi(get_tile $key)))")
(action_tile "H" "(setq h(atoi(get_tile $key)))")
(action_tile "zj" "(setq zj(atoi(get_tile $key)))")
(action_tile "LF" "(setq lf(atoi(get_tile $key)))")
(start_dialog)
   (unload_dialog dcl_ia)
(setq os(getvar "osmode"))
(setvar "osmode" 0)
(if (> h lf) (progn
   (setq gr(getreal"输入轮毂端面半径:gr="))
   (setq yr(getreal"输入轮缘端面半径:yr="))
   (setq s(/ (- h lf) 2))
   (setq l(- h s))
      )
)
(setq rf(/ (* (- z 2.5) m) 2)
rj(/ (* m z 0.939693) 2)
r (/ (* z m) 2)
ra(/ (* (+ z 2) m) 2)
tt(* m pi)
pj(/ 36.0 z)
a (/ (* 1.25 m) (cos (* 20 (/ pi 180))))
pt0(list 200.0 30.0 0.0)
pt1(polar pt0 0 (/ tt 4))
pt2(polar pt0 pi (/ tt 4))
pt3(polar pt1 (* 110 (/ pi 180)) a)
pt5(polar pt1 (* -70 (/ pi 180)) a)
pt4(polar pt2 (* 70 (/ pi 180)) a)
pt6(polar pt2 (* 250 (/ pi 180)) a)
pt7(polar pt6 (* -90 (/ pi 180)) 2)
)
(command "layer" "m" "11" "c" 1 "" ""
    "layer" "m" "12" "c" 2 "" ""
    "layer" "m" "13" "c" 252 "" ""
    "layer" "s" "13" ""
    "pline" pt7 pt6 pt4 pt3 pt5
)
(setq i 1)
(while (<= i 7)
    (setq pt6(polar pt6 0 tt)
   pt4(polar pt4 0 tt)
   pt3(polar pt3 0 tt)
   pt5(polar pt5 0 tt)
    )
    (command pt6 pt4 pt3 pt5)
    (setq i(+ i 1))
)
(setq pt8(polar pt5 (* -90 (/ pi 180)) 2))
(command pt8 "c")
(setq pt(polar pt0 (* 180 (/ pi 180)) (* 4 tt)))
(command "move" "l" "" pt0 pt)
(setq e0(entlast))
(command "layer" "s" 11 "")
(setq p0(polar pt0 (* 90 (/ pi 180)) r))
(command "circle" p0 ra)
(command "region" "l" "")
(setq e10 (entlast))
(command "layer" "s" "12" "")
(setq j 1)
(while (<= j z)
    (setq i 1)
    (while (<= i 10)
      (command "rotate" e10 "" p0 pj)
      (setq yd(* r pj (/ pi 180) i))
      (setq pt(polar pt0 0 yd))
      (command "copy" e0 "" pt0 pt)
      (command "region" "l" "")
      (setq e1(entlast))
      (command "subtract" e10 "" e1 "")
      (setq i (+ i 1))
    )
    (setq j(+ j 1))
)
(command "layer" "s" "11" "")
(command "extrude" e10 "" h 0)
(setq e5 (entlast))
(command "erase" e0 "")
(if (> h lf)(progn
(command "circle" p0 yr)
(setq e1(entlast))
(command "extrude" e1 "" s 5)
(setq e1(entlast))
(command "circle" p0 gr)
(setq e2(entlast))
(command "extrude" e2 "" s -5)
(setq e2(entlast))
(command "subtract" e1 "" e2 "")
(setq pt(list (car p0) (car (cdr p0)) h))
(setq s(- 0 s))
(command "circle" pt yr)
(setq e3(entlast))
(command "extrude" e3 "" s 10)
(setq e3(entlast))
(command "circle" pt gr)
(setq e4(entlast))
(command "extrude" e4 "" s -10)
(setq e4 (entlast))
(command "subtract" e3 "" e4 "")
(command "cylinder" p0 (/ zj 2) h)
(setq e4(entlast))
(command "subtract" e5 "" e1 e3 e4 "")
      )
               (progn (command "cylinder" p0 (/ zj 2) h)
   (setq e4(entlast))
   (command "subtract" e5 "" e4 "")
      )
    )
(setvar "osmode" os)
想请教大神们如何将这两个LSP和DCL加载应用?


xiyyanggege 发表于 2015-1-25 15:44:59

本帖最后由 xiyyanggege 于 2015-1-25 15:50 编辑

本人大学刚接触CAD,求大神们帮忙啊

鱼与熊掌 发表于 2015-1-25 18:56:52

建议使用vlide调试
页: [1]
查看完整版本: 求大神帮忙看看我这程序有什么问题